/*
  Na zakoĹ„czenie warto powrĂłciÄ‡ do funkcji oszczÄ™dzania energii i wykorzystaÄ‡ przedstawionÄ… ostatnio funkcjÄ™:
  ESP.deepSleep(300000000); //300s uĹ›pienia i reset przez RTC
  ktĂłra znaczÄ…co zredukuje moc pobieranÄ… przez ESP8266 a po poĹ‚Ä…czeniu wyprowadzenia D0 z RST pozwoli na zresetowanie moduĹ‚u przez RTC po zadanym czasie i ponowne wykonanie kodu wysyĹ‚ajÄ…cego dane.
*/


//parametry logowania do sieci WiFi
//const char* ssid = "FunBox-662C";
const char* ssid = "ssid";
const char* password = "pass";


//String ip_pirometr = "192.168.1.22"; // the remote IP address
char ip_pirometr[] = "192.168.2.51"; // the remote IP address
int port_pirometr = 80; // the destination port

#define BROADCAST   "192.168.2.255"
unsigned int localUdpPort = 2102;     // INFO: jest jeszcze udp broadcast
#define Co_ILE_NA_UDP       30000UL

//dane konta na thingspeak
const char * apiKey = "key";
unsigned long myChannelNumber = 1;
#define URL_REJESTARTORA  "https://thingspeak.com/channels/xxxxx"
// "184.106.153.149" lub api.thingspeak.com
const char* server = "api.thingspeak.com";


#define TXT_SCREEN_SLEEP      "."




#define UART_SPEED    230400
#define PB_USER   D5                // przyciski uzytkownika


#include <NtpClientLib.h>     // NTP
#include <TimeLib.h>          // NTP
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
WiFiUDP Udp;    // Broadcast
WiFiUDP UDP;    // Pirometr
#include <ThingSpeak.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include "DHTesp.h"         // biblioteka DHT
#include <Wire.h>

//   #define SSD1306_128_32
//   #define SSD1306_96_16
#define SSD1306_128_64
#define SSD1306_128_64
#include "SSD1306.h"
//SSD1306  display(0x3c, D5, D6); // Na uniwersalce SSD1306 based 128x32 z KAMAMI
SSD1306  display(0x3c, D1, D2); // WEMOS z OLED SSD1306 based 128x64


//----- Czujnik cisnienia
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>
Adafruit_BMP280 bme; // I2C


//----- Czujnik wilgotnosci
#define DHTPIN D4 //2          // numer pinu sygnaĹ‚owego (2 to D4 na WemosNODE)
#define DHTTYPE DHT22         // typ czujnika (DHT11). Jesli posiadamy DHT22 wybieramy DHT22
//----- DS18B20
#define ONE_WIRE_BUS    D3     //konfiguracja wyprowadzenia na ktĂłrym pracuje magistrala 1-wire


//DHT dht(DHTPIN, DHTTYPE); // definicja czujnika
#ifdef ESP32
#pragma message(THIS EXAMPLE IS FOR ESP8266 ONLY!)
#error Select ESP8266 board.
#endif
DHTesp dht;


#define REK_MAX_URZADZEN      10
#define REK_MAX_POL           20
#define REK_MAX_STRING        20
char rekordy[REK_MAX_URZADZEN][REK_MAX_POL][REK_MAX_STRING];    // bardziej elegancko byloby zrobic strukture
#define MAX_LEN_IP      20
char ip_u[ REK_MAX_URZADZEN ][MAX_LEN_IP];
uint8_t zdalnych;


uint16_t dtYYYY;
uint8_t dtMIES, dtDD, dtGG, dtMM, dtSS;


//#define DISPLAY_WIDTH   128
//#define DISPLAY_HEIGHT  32
// Initialize the OLED display using Wire library
#define DRAW(s) \
  display.clear(); \
  display.setTextAlignment(TEXT_ALIGN_CENTER_BOTH); \
  display.drawString(DISPLAY_WIDTH/2, DISPLAY_HEIGHT/2, s); \
  display.display()


void drawXbmR(int16_t xMove, int16_t yMove, int16_t width, int16_t height, const uint8_t *xbm) {
  int16_t widthInXbm = (width + 7) / 8;
  uint8_t data = 0;

  for (int16_t y = 0; y < height; y++) {
    for (int16_t x = 0; x < width; x++ ) {
      if (x & 7) {
        data <<= 1; // Move a bit
      } else {  // Read new data every 8 bit
        data = pgm_read_byte(xbm + (x / 8) + y * widthInXbm);
      }
      // if there is a bit draw it
      if (data & 0x80) {
        display.setPixel(xMove + x, yMove + y);
      }
    }
  }
}


//rozdzielczoĹ›Ä‡ odczytu temperatury
#define TEMPERATURE_PRECISION 12
//maksymalna iloĹ›Ä‡ czujnikĂłw na magistrali
#define MAX_SENSORS 10
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
DeviceAddress sensors_addr[MAX_SENSORS];
byte device_count = 0;


WiFiClient client;

float dth_t, dth_h, bme_presure, bme_temp;
byte dth_presence = false, FL_findDS;
byte StBme280 = false;
float temp[MAX_SENSORS];
byte AdrI2c[10];
#define MAX_I2C   10
char static buf[10000];


#include "ESP8266WebServer.h"
ESP8266WebServer  webServer(80);

void IndexHandler()
{
  //  webServer.send("Location", "/index.html",true );  // przekierowanie na plik w SPIFFS
  //  webServer.send( 302,"text/plane" );    //EP 2018-12 str 31

  //  webServer.send( 200, "text/plain", "Czas uruchomienia " + String( millis()) + "ms" );

  char txt[100];  //1111111111222222222233333333334444444444555555555566666666667777777777888888888899999999990000000000


  strcpy( buf, "<head><title>Mini stacja pogodowa</title></head>" );


  sprintf( txt, "SysTick: %d sekund", millis() / 1000 ); strcat( buf, txt );
  sprintf( txt, "<BR>%d-%d-%02d %d:%02d:%02d<P><P>", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); strcat( buf, txt );


  if ( dth_presence ) {
    sprintf( txt, "DHT Wilgotnosc: %1.1f%% Temp.: % 1.1f*C", dth_h, dth_t );
    strcat( buf, txt );
  }
  else {
    strcat( buf, "DTH Err" );
  }


  if ( StBme280 ) {
    //    sprintf( txt, "<BR>BMP280 Pressure: %1.0fhPa Temperature: %1.0f*C  Approx altitude: %1.0fm",  bme_presure / 100, bme_temp, bme.readAltitude(1013.25) );
    sprintf( txt, "<BR>BMP280 Cisnienie: %1.0fhPa Temp.: %1.0f*C",  bme_presure / 100, bme_temp );
    strcat( buf, txt );
  }
  else {
    strcat( buf, "BMP Err" );
  }


  strcat( buf, "\n<P><TABLE cellpadding='5'>" );
  for (byte n = 0; n < MAX_SENSORS && n < device_count; n++) {
    //    sprintf( txt, "<BR>%d %1.2f*C", sensors.getTempC(sensors_addr[n]) );
    sprintf( txt, "<TR><TD>T%d</TD><TD>%6.2f*C</TD></TR>\n", n + 1, temp[n + 2] ); strcat( buf, txt );
  }
  strcat( buf, "</TABLE>" );


  strcat( buf, "<P> <A HREF='"URL_REJESTARTORA"' TARGET='_BLANK'>Rejestrator</A>" );
  strcat( buf, " <input type='button' value='Reload Page' onClick='document.location.reload(true)'>\r" );
  strcat( buf, " <A HREF='/s'>Skanuj I2C</A>" );


  //  webServer.send( 200, "text / plain", buf );
  webServer.send( 200, "text/html; charset=iso-8859-2", buf );
  /*
    void  send (int code, const String &content_type, const String &content)
    void  sendHeader (const String &name, const String &value, bool first=false)
    void  sendContent (const String &content)
  */
}


void IndexHandlerScan()
{
  char txt[100];  //1111111111222222222233333333334444444444555555555566666666667777777777888888888899999999990000000000


  strcpy( buf, "<head><title>Mini stacja pogodowa</title></head>" );


  sprintf( txt, "SysTick: %d sekund<P>Skanowanie I2C: ", millis() / 1000 );
  strcat( buf, txt );
  for (byte x = 0; x < MAX_I2C; x++) {
    if ( AdrI2c[x] ) {
      sprintf( txt, "0x%02X ", AdrI2c[x] );
      strcat( buf, txt );
    }
  }
  strcat( buf, "END" );

  strcat( buf, "<P><A HREF='/i'>Wstecz</A>" );

  //  webServer.send( 200, "text / plain", buf );
  webServer.send( 200, "text/html; charset=iso-8859-2", buf );
}


void notFoundHandler()
{
  webServer.send( 404, "text/plain", "Strona nie istnieje." );
}
//w loop():
//  webServer.handleClient();
//w setup():
//  webServer.on( " / ", IndexHandler );    // tych deklaracji moze byc wiele,co by to nie znaczylo
//  webServer.onNotFound( notFoundHandler );
//  webServer.begin();



boolean syncEventTriggered = false; // True if a time even has been triggered
NTPSyncEvent_t ntpEvent; // Last triggered event
int8_t timeZone = 1;
int8_t minutesTimeZone = 0;
bool wifiFirstConnected = true;//false;


// Start NTP only after IP network is connected
void onSTAGotIP (WiFiEventStationModeGotIP ipInfo) {
  Serial.printf ("***NTP*** Got IP: %s\r\n", ipInfo.ip.toString ().c_str ());
  Serial.printf ("Connected: %s\r\n", WiFi.status () == WL_CONNECTED ? "yes" : "no");
  wifiFirstConnected = true;
}


void onSTAConnected (WiFiEventStationModeConnected ipInfo) {
  Serial.printf ("***NTP*** Connected to %s\r\n", ipInfo.ssid.c_str ());
}


// Manage network disconnection
void onSTADisconnected (WiFiEventStationModeDisconnected event_info) {
  Serial.printf ("***NTP*** Disconnected from SSID: %s\n", event_info.ssid.c_str ());
  Serial.printf ("Reason: %d\n", event_info.reason);
  //NTP.stop(); // NTP sync can be disabled to avoid sync errors
}


void processSyncEvent(NTPSyncEvent_t ntpEvent) {
  if (ntpEvent) {
    Serial.print ("***NTP*** Time Sync error: ");
    if (ntpEvent == noResponse)
      Serial.println ("NTP server not reachable");
    else if (ntpEvent == invalidAddress)
      Serial.println ("Invalid NTP server address");
  } else {
    Serial.print ("***NTP*** Got NTP time: ");
    Serial.println (NTP.getTimeDateString (NTP.getLastNTPSync ()));

    //----- Rozlozenie datay i czasu
    char txt[50];
    String str = NTP.getTimeDateString(); strcpy( txt, str.c_str() );
    // 0000000000111111111
    // 0123456789012345678
    // 10:11:07 26/10/2019
    //    sscanf( txt, "%d02:%d02:%d02 %d02/%d02/%d04", &dtGG, &dtMm, &dtSS, &dtDD, &dtMIES, &dtYYYY );
    //INFI: sscanf wywala program i to dziwnie. jak zmienne sa globalne zawsze problem. jak lokalne ok z czasem sscanf daty wysypuje
    //   sscanf( txt, "%d02", &dtGG );
    dtGG = (txt[0] - '0') * 10;
    dtGG += (txt[1] - '0');

    //   sscanf( txt + 3, "%d02", &dtMM );
    dtMM = (txt[3] - '0') * 10;
    dtMM += (txt[4] - '0');

    //   sscanf( txt + 6, "%d02", &dtSS );
    dtSS = (txt[6] - '0') * 10;
    dtSS += (txt[7] - '0');

    //   sscanf( txt + 6, "%d02", &dtDD );
    dtDD = (txt[9] - '0') * 10;
    dtDD += (txt[10] - '0');

    //   sscanf( txt + 12, "%d02", &dtMIES );
    dtMIES = (txt[12] - '0') * 10;
    dtMIES += (txt[13] - '0');

    //   sscanf( txt + 15, "%d02", &dtYYYY );
    dtYYYY = (txt[15] - '0') * 1000;
    dtYYYY += (txt[16] - '0') * 100;
    dtYYYY += (txt[17] - '0') * 10;
    dtYYYY += (txt[18] - '0');

    sprintf( txt, " %d-%d-%d% d:%d:%d\n\r", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); Serial.print( txt );
  }
}


//------------------------------------------------------------
void aktualizujRTC() {
  uint32_t static tim;

  uint32_t ad, r, ms = millis();
  if ( ms >= tim ) {
    ad = (ms - tim) / 1000;   // liczba sekund od poprzedniego wywolania funkcji (najczesciej zero, chyba, ze loop trwal >= 2 sekundy)
    r = (ms - tim) % 1000;    // reszta ms od poprzedniego wywolania funkcji
    dtSS += ad;               // Dodajemy roznice sekund gdy loop >= 2 sekundy
    tim = ms + 1000 - r;      // Tick + sekunda - reszta

    //----- Standardowy RTC -----//
    if ( ++dtSS >= 60 ) {
      dtSS -= 60;
      if ( ++dtMM >= 60 ) {
        dtMM = 0;
        if ( ++dtGG >= 24 ) { // Zmiane czasu sobie darujemy, nie po to jest NTP
          dtGG = 0;
          dtDD++;
          if ( (dtMIES == 1 && dtDD > 31) ||      // Liczba dni zalezy od miesiaca, lata przestepne sobie darujemy, nie po to jest NTP
               (dtMIES == 2 && dtDD > 28) ||
               (dtMIES == 3 && dtDD > 31) ||
               (dtMIES == 4 && dtDD > 30) ||
               (dtMIES == 5 && dtDD > 31) ||
               (dtMIES == 6 && dtDD > 30) ||
               (dtMIES == 7 && dtDD > 31) ||
               (dtMIES == 8 && dtDD > 31) ||
               (dtMIES == 9 && dtDD > 30) ||
               (dtMIES == 10 && dtDD > 31) ||
               (dtMIES == 11 && dtDD > 30) ||
               (dtMIES == 3 && dtDD > 31)
             ) {
            dtDD = 1;
            if ( ++dtMIES > 12 ) dtYYYY++;
          }
        }
      }
    }
    //  char txt[100];
    //  sprintf( txt, " [%d-%d-%02d %d:%02d:%02d] ", dtYYYY, dtMIES, dtDD, dtGG, dtMM, dtSS ); Seria.print( txt );
  }
}



void  skanujIIC()
{
  byte error, address;
  int nDevices;
  nDevices = 0;


  Serial.println("\n\r>>> Przeszukuje I2C...");

  byte adr = 0;
  for (byte x = 0; x < MAX_I2C; x++) AdrI2c[x] = 0;

  for (address = 1; address < 127; address++ )
  {
    // The i2c_scanner uses the return value of
    // the Write.endTransmisstion to see if
    // a device did acknowledge to the address.
    Wire.beginTransmission(address);
    error = Wire.endTransmission();

    if (error == 0) {
      Serial.print("I2C device found at address 0x");
      if (address < 16) Serial.print("0");
      Serial.print(address, HEX);
      Serial.println(" !");
      if ( adr < MAX_I2C ) AdrI2c[adr++] = address;

      nDevices++;
    }
    else if (error == 4)
    {
      Serial.print("Unknown error at address 0x");
      if (address < 16)
        Serial.print("0");
      Serial.println(address, HEX);
    }
  }


  if (nDevices == 0)
    Serial.println("No I2C devices found\n");
  else
    Serial.println("done\n");
}


#define UDP_RX_MAX_SIZE     255
//------------------------------------------------------------
void obsluga_udp() {
  uint32_t static CzasDoUDP;
  char incomingPacket[UDP_RX_MAX_SIZE];


  int packetSize = Udp.parsePacket();
  if ( packetSize ) {


    char ipNadawcy[20];
    strncpy( ipNadawcy, Udp.remoteIP().toString().c_str(), MAX_LEN_IP );

    //    Serial.printf( "\n\r***Received %d bytes from %s, port %d", packetSize, Udp.remoteIP().toString().c_str(), Udp.remotePort() );
    Serial.printf( "\n\r***Received %d bytes from %s, port %d", packetSize, ipNadawcy, Udp.remotePort() );
    int len = Udp.read(incomingPacket, UDP_RX_MAX_SIZE);
    if (len > 0)
    {
      incomingPacket[len] = '\0';
    }
    Serial.printf( "\n\r********** UDP packet contents: ***************\n\r%s\n", incomingPacket );


    //----- Szukanie urzadzenia o odczytanym IP -----//
    char rez = false, u = 0;
    for ( uint8_t x = 0; x < REK_MAX_URZADZEN; x++) {
      if ( ! strcmp( ip_u[ x ], ipNadawcy ) ) {
        u = x;
        rez = true;
        Serial.printf( "\n\rZnaleziono IP w tablicy, id=%d", u );
        break;
      }
    }

    //----- Jesli nie znaleziono IP -----//
    if ( ! rez ) {
      Serial.print( "\n\r*** Nie znaleziono IP w tablicy" );
      uint8_t x;
      for (  x = 0; x < REK_MAX_URZADZEN; x++) { // Szukanie wolnego miejsca w tablicy
        if ( ip_u[ x ][0] == 0 ) {  // Jesli jest wolne miejsce
          strncpy( ip_u[ x ], ipNadawcy, MAX_LEN_IP );    // Dodanie wpisu
          u = x;
          zdalnych = u + 1;
          Serial.printf( "\n\r*** Dodano IP do tablicy, id=%d", zdalnych );
          break;
        }
      }
      if ( x == REK_MAX_URZADZEN ) {
        u = 0xFF;        // todo: brak miejsca
        Serial.print( "\n\r*** Brak miejsca na IP w tablicy" );
      }
    }


    if ( u < REK_MAX_URZADZEN ) {
      Serial.printf( "\n\r** Zdalnych %d", zdalnych );
      //----- funkcja umieszczajaca kolejno znalezione rekordy w tablicy -----//
      uint8_t r = 0;  // Nr rekordu
      uint16_t s = 0; // poczatek stringu
      for (uint16_t x = 0; x < strlen(incomingPacket); x++) {
        if ( incomingPacket[ x ] == '\n' || incomingPacket[ x ] == '\r' ) {
          Serial.print( "+" );
          uint16_t e = x - s;
          if ( e >= REK_MAX_STRING - 1 ) e = REK_MAX_STRING - 1; // Ograniczenie dlugosci stringow
          strncpy( rekordy[ u ][ r++ ], incomingPacket + s, e );   // String do tablicy
          if ( incomingPacket[ x ] == '\n' || incomingPacket[ x ] == '\r' ) x++;    // Przeskakujemy drogi znak CR lub LF
          s = x;
          if ( r >= REK_MAX_POL ) break; // Ograniczenie liczby rekordow
        }
      }
      for ( uint8_t x = 0; x < r; x++) {
        char txt[100];
        sprintf( txt, "\n\r[%d][%d]: '%s'", u, x, rekordy[ u ][ x ] ); Serial.print( txt );
      }
    }


    //----- Potwierdzenie odbioru -----//
    //  if ( strncmp( incomingPacket, "ACK:", 4) ) {    // Jesli nie ACK
    if ( false ) {
      Serial.print( "Send ACK " );
      uint32_t id;
      sscanf( incomingPacket + 4 , "%08x", &id );   // odczytanie ID z ramki
      //----- Potwierdzenie -----//
      Udp.beginPacket(Udp.remoteIP(), Udp.remotePort());
      Udp.write( "\n\rACK: " );
      char txt[100];
      sprintf( txt, "%08x ", id ); Udp.write( txt );   // ID ramki
      Serial.print( txt );
      Udp.write( WiFi.localIP().toString().c_str() );
      Udp.endPacket();
    }


  }


  //----- Nadawanie UDP -----//
  if ( millis() > CzasDoUDP ) {
    CzasDoUDP = millis() + Co_ILE_NA_UDP + random( 0, 500 );

    Serial.print( "\n\r*** Send UDP ... " );

    Udp.beginPacket( BROADCAST, localUdpPort );
    uint32_t static nr;
    char txt[100];
    sprintf( txt, "ID: %08x\n\r", ++nr ); Udp.write( txt ); // Nr ramki
    Udp.write( "NAME: Salon\n\r" );                        // Nazwa (opis)
    //Udp.write( WiFi.localIP().toString().c_str() );
    Udp.write( "TYPE: MiniStacja Pogodowa AVT-3249\n\r" );              // Nazwa urzadzenia
    if ( StBme280 ) {
      sprintf( txt, "bar=%1.0fhPa\n\r", bme_presure / 100 ); Udp.write( txt );
    }
    if ( dth_presence ) {
      sprintf( txt, "H  =%1.1f%%\n\r", dth_h ); Udp.write( txt );
    }
    for (byte n = 0; n < MAX_SENSORS && n < device_count; n++) {
      sprintf( txt, "T%02d =%6.2f*C\n\r", n + 1, temp[n + 2] ); Udp.write( txt );
    }
    uint32_t tim = micros();
    Udp.endPacket();
    sprintf( txt, " %dus", micros() - tim ); Serial.print( txt );
  }


}


byte oxx, oyy;
//====================================================================//
uint32_t CzasDoResetu, CzasDoRstWifi;

void setup() {
  byte n = 0;
  byte mac[6];


  pinMode( PB_USER, INPUT_PULLUP );


  Serial.begin(UART_SPEED);
  Serial.println();
  Serial.println("************ START SETUP *********");

  Wire.begin();
  skanujIIC();


  //  dht.begin();            // inicjalizacja czujnika
  // Autodetect is not working reliable, don't use the following line
  // dht.setup(17);
  // use this instead:
  dht.setup(DHTPIN, DHTesp::DHT22); // Connect DHT sensor to GPIO 17


  display.init();
  // display.invertDisplay();
  // display.flipScreenVertically(); // Orientacja ekranu - obracanie obrazu o 180 stopni
  display.setColor(WHITE);
  display.setFont(ArialMT_Plain_24);
  display.clear();

  //    display.setTextAlignment(TEXT_ALIGN_CENTER_BOTH);
  display.drawString(oxx + 30, oyy + 0, "Restart");
  //     display.drawLine(0, 0, 64, 32);  // poziom, pion, poziom, pion
  display.display();
  //display.drawPixel(10,20,0);


  //Ĺ‚Ä…czymy siÄ™ do sieci WiFi
  Serial.print("Laczenie do sieci SSID: ");
  Serial.print(ssid);
  Serial.println("");
  WiFi.begin(ssid, password);

  WiFi.macAddress(mac);
  for (n; n < 6; n++) {
    Serial.print(mac[n], HEX);
    if (n < 5)
      Serial.print(":");
    else
      Serial.println("");
  }
  n = 30;
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.print(".");

    oxx = random(0, 8);
    oyy = random(0, 8);

    char txt[20];
    sprintf( txt, "Wait %2d", n );
    display.clear();
    display.drawString(oxx + 30, oyy + 20, txt );
    //     display.drawLine(0, 0, 64, 32);  // poziom, pion, poziom, pion
    display.display();
    if ( !n-- ) {
      break;
      //ESP.restart(); Serial.println("restart ");
    }
  }
  if ( WiFi.status() == WL_CONNECTED ) {
    Serial.println("\n\rPolaczenie WiFi OK");
    Serial.println(WiFi.localIP());
  }
  else {
    Serial.println("\n\rBlad polaczenia Wi-Fi");
#define DEF_RESTART_WIFI    (5 * 60 * 10000)
    CzasDoRstWifi = millis() + DEF_RESTART_WIFI;
  }


  skanujIIC();


  if (!bme.begin()) {
    StBme280 = false;
    Serial.println("******* Could not find a valid >>>> BMP280 <<<<< sensor, check wiring!");
  }
  else {
    StBme280 = true;
    Serial.println(">>>> BMP280 Finded <<<<<");
  }


  ThingSpeak.begin(client);


  Udp.begin(localUdpPort);
  Serial.printf("\n\rNow listening at IP %s, UDP port %d\n", WiFi.localIP().toString().c_str(), localUdpPort );


  //----- WysyĹ‚ka UDP do pirometru
  if ( WiFi.status() == WL_CONNECTED ) {
    //  UDP.beginPacket("192.168.1.22", port_pirometr);
    UDP.beginPacket(ip_pirometr, port_pirometr);
    UDP.println("\n\r\n\rRestart");
    UDP.endPacket();
    /*
           char packetBuffer[UDP_TX_PACKET_MAX_SIZE]; //buffer to hold incoming packet,

        int packetSize = UDP.parsePacket();
        if(packetSize)
        {

        UDP.read(packetBuffer,UDP_TX_PACKET_MAX_SIZE);

        }

    */
    /*
      //----- Pierwszy transfer po resecie
      ThingSpeak.setField(1, 5); // WilgotnoĹ›Ä‡
      ThingSpeak.setField(2, 10);
      ThingSpeak.setField(3, 10);
      ThingSpeak.setField(4, -20);
      Serial.println("wysyĹ‚anie danych do serwera...");
      ThingSpeak.writeFields(myChannelNumber, apiKey);
      Serial.println("wysyĹ‚ano albo i nie");
    */

    /*
      Serial.println("\n\rCzekam 20 sekund...");
      delay( 20000 );
      //----- Drugi transfer po resecie
      ThingSpeak.setField(1, 95);// WilgotnoĹ›Ä‡
      ThingSpeak.setField(2, 29);
      ThingSpeak.setField(3, 29);
      ThingSpeak.setField(4, 45);
      Serial.println("wysyĹ‚anie danych do serwera...");
      ThingSpeak.writeFields(myChannelNumber, apiKey);
      Serial.println("wysyĹ‚ano albo i nie");
    */
  }


  static WiFiEventHandler e1, e2, e3;

  NTP.onNTPSyncEvent ([](NTPSyncEvent_t event) {
    ntpEvent = event;
    syncEventTriggered = true;
  });

  // Deprecated
  /*WiFi.onEvent([](WiFiEvent_t e) {
      Serial.printf("Event wifi -----> %d\n", e);
    });*/

  e1 = WiFi.onStationModeGotIP (onSTAGotIP);// As soon WiFi is connected, start NTP Client
  e2 = WiFi.onStationModeDisconnected (onSTADisconnected);
  e3 = WiFi.onStationModeConnected (onSTAConnected);


  webServer.on( "/", IndexHandler );
  webServer.on( "/i", IndexHandler );
  webServer.on( "/s", IndexHandlerScan );
  webServer.onNotFound( notFoundHandler );
  webServer.begin();


  //------ End Setup --------//
  Serial.println("************ END SETUP *********");
  CzasDoResetu = millis() + 24 * 60 * 60 * 1000; // 24h
}


// function to print a device address
void printAddress(DeviceAddress deviceAddress)
{
  for (uint8_t i = 0; i < 8; i++)
  {
    // zero pad the address if necessary
    if (deviceAddress[i] < 16) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
  }
}

//--------------------





/*
  //------
  //IPAddress timeServer(193.110.137.171); // time.nist.gov NTP server
  //char timeServerIP[] = "193.110.137.171"; // time.nist.gov NTP server
  IPAddress timeServerIP;
  const char* ntpServerName = "ntp.itl.waw.pl"; //  193.110.137.171
  //const char* ntpServerName = "time.nist.gov";
  WiFiUDP NtpUdp;
  //const int NTP_PACKET_SIZE = 48; // NTP time stamp is in the first 48 bytes of the message
  byte NtpPacketBuffer[ NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets


  // send an NTP request to the time server at the given address
  void sendNTPpacket(IPAddress& address) {
  Serial.println("****************** sending NTP packet...");
  // set all bytes in the buffer to 0
  memset(NtpPacketBuffer, 0, NTP_PACKET_SIZE);
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  NtpPacketBuffer[0] = 0b11100011;   // LI, Version, Mode
  NtpPacketBuffer[1] = 0;     // Stratum, or type of clock
  NtpPacketBuffer[2] = 6;     // Polling Interval
  NtpPacketBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  NtpPacketBuffer[12]  = 49;
  NtpPacketBuffer[13]  = 0x4E;
  NtpPacketBuffer[14]  = 49;
  NtpPacketBuffer[15]  = 52;

  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp:
  NtpUdp.beginPacket(address, 123); //NTP requests are to port 123
  NtpUdp.write(NtpPacketBuffer, NTP_PACKET_SIZE);
  NtpUdp.endPacket();
  }
*/


const uint8_t charStopnie16x12[] = {
  0B00110000, 0B01111100,
  0B01001000, 0B10000010,
  0B01001001, 0B00000001,
  0B00110010, 0B00000000,
  0B00000010, 0B00000000,
  0B00000010, 0B00000000,
  0B00000010, 0B00000000,
  0B00000010, 0B00000000,

  0B00000010, 0B00000000,
  0B00000001, 0B00000001,
  0B00000000, 0B10000010,
  0B00000000, 0B01111100,
};


//====================================================================//
void loop() {
  uint32_t CzasObiegu = millis();
  uint32_t static Refresh, timLcdOff;
  bool static fl_LCDoff;


  webServer.handleClient();

  obsluga_udp();

  aktualizujRTC();


  if ( millis() > CzasDoResetu ) {
    Serial.print("\n\r*** Abort ***");
    abort();
  }


  bool static prevSw, switch_user;
  bool sw = digitalRead( PB_USER );
  uint8_t static ekran;
  uint32_t static timSw;
  if ( prevSw != sw && millis() > timSw ) {
    prevSw = sw;
    timSw = millis() + 100;   // Blokada SW na 100 ms
    if ( ! sw ) switch_user = true; else switch_user = false;
  }
  bool static prevSwUser;
  if ( prevSwUser != switch_user ) {
    prevSwUser = switch_user;
    if ( switch_user ) {
      Serial.print(">>>>>>>> PB ON <<<<<<<<\n\r");

      if ( ! fl_LCDoff ) {    // Jesli LWD juz wlaczony
        if ( ++ekran > zdalnych ) ekran = 0;  // kolejny ekran
        Serial.printf( "********** Ekran %d", ekran );
      }

      // Wlaczenie LCD
      fl_LCDoff = false;
      Refresh = 0;  // Wymuszenie odswierzenia LCD
      timLcdOff = millis() + 30000;   // czas do wylaczenia LCD
    }
  }
  if ( ! timLcdOff ) timLcdOff = 60000;   // Po resecie wyswietlanie 60 sek
  if ( millis() >= timLcdOff ) {
    timLcdOff = 0xFF000000;   // Zatrzymanie zliczania
    fl_LCDoff = true;
    Refresh = 0;  // Wymuszenie odswierzenia LCD
    ekran = 0;

    Serial.print("*** LCD Auto Off\n\r");
  }



  if ( millis() > Refresh  )  {
#define   DEF_REFRESH_LCD   5000UL
    Refresh = millis() + DEF_REFRESH_LCD;
    //----- Minimaluzuje wypalanie ekranu -----//
    oxx = random(0, 6);
    oyy = random(0, 6);


    Serial.println();


    CzasObiegu = millis();
    // Odczyt temperatury i wilgotnoĹ›ci powietrza
    // dth_t = dht.readTemperature();
    // dth_h = dht.readHumidity();
    dth_t = dht.getHumidity();
    dth_h = dht.getTemperature();
    //  Serial.print(dht.getStatusString());

    //
    // Sprawdzamy czy sÄ… odczytane wartoĹ›ci
    if (isnan(dth_t) || isnan(dth_h)) {
      dth_presence = false;
      // JeĹ›li nie, wyĹ›wietlamy informacjÄ™ o bĹ‚Ä™dzie
      Serial.println("Blad odczytu danych z czujnika");
    } else {
      dth_presence = true;
      // JeĹ›li tak, wyĹ›wietlamy wyniki pomiaru
      Serial.print("DHT Wilgotnosc: ");
      Serial.print(dth_h);
      Serial.print(" % ");
      Serial.print("DHT Temperatura: ");
      Serial.print(dth_t);
      Serial.println(" *C");
      temp[0] = dth_h;
      temp[1] = dth_t;
    }
    Serial.print("Czasodczytu DHT "); Serial.println( millis() - CzasObiegu);


    //----- Odczyt cisnienia -----//
    if (!bme.begin()) {
      // if ( isnan(bme_presure) || isnan(bme_temp) ) {
      StBme280 = false;
    }
    else {
      StBme280 = true;
    }
    //
    CzasObiegu = millis();
    bme_temp = bme.readTemperature();
    bme_presure = bme.readPressure();
    //
    if ( StBme280 ) {
      Serial.print("\n\rBMP280 Temperature = ");
      Serial.print(bme_temp);
      Serial.println(" *C");

      Serial.print("BMP280 Pressure = ");
      Serial.print(bme_presure / 100);
      Serial.println(" hPa");

      Serial.print("BMP280 Approx altitude = ");
      Serial.print(bme.readAltitude(1013.25)); // this should be adjusted to your local forcase
      Serial.println(" m");
    }
    else {
      Serial.println("Blad BME280");
    }
    Serial.print("Czasodczytu BMP280 "); Serial.println( millis() - CzasObiegu);


    byte static cntDS = 1;
    if ( !--cntDS ) {
      cntDS = 45000UL / DEF_REFRESH_LCD; // Co 45 sekund (45/5 = 9 obiegów pętli wyszukiwanie czujników
      FL_findDS = true;

      //urzÄ…dzenia na magistrali
      sensors.begin();
      device_count = sensors.getDeviceCount();
      Serial.print("***** Iloosc znalezionych urzadzen: ");
      Serial.print(device_count);
      Serial.print("Maksymalna : ");
      Serial.println(MAX_SENSORS);

      for (byte n = 0; n < MAX_SENSORS && n < device_count; n++)
        if (sensors.getAddress(sensors_addr[n], n)) {
          Serial.print("Urzadzenie: ");
          Serial.print(n);
          Serial.print(" przypisane do adresu: ");
          printAddress(sensors_addr[n]);
          Serial.println(" ");
        } else {
          Serial.print("Urzadzenie: ");
          Serial.print(n);
          Serial.println("blad wyszukiwania adresu.");
        }

      //rozdzielczoĹ›Ä‡ 9bit
      for (byte n = 0; n < MAX_SENSORS && n < device_count; n++)
        sensors.setResolution(sensors_addr[n], TEMPERATURE_PRECISION);
    }
    Serial.print("\n\rOdczyt danych DS18B20..");
    CzasObiegu = millis();
    sensors.requestTemperatures();
    Serial.print("Czas requestTemperatures "); Serial.println( millis() - CzasObiegu);


    CzasObiegu = millis();
    for (byte n = 0; n < MAX_SENSORS && n < device_count; n++) {
      Serial.print("Czujnik: ");
      Serial.print(n);
      Serial.print(" Temperatura: ");
      temp[n + 2] = sensors.getTempC(sensors_addr[n]);
      Serial.println(temp[n + 2]);
    }
    //
    Serial.print("Czas odczytu DS18b20 ");  Serial.println( millis() - CzasObiegu);


    CzasObiegu = millis();
    skanujIIC();
    Serial.print("Czas skanowania I2C ");  Serial.println( millis() - CzasObiegu);


    Serial.print("\n\rtick="); Serial.print( millis() / 1000 ); Serial.print(" doRst="); Serial.println( CzasDoResetu / 1000 );
    if ( WiFi.status() == WL_CONNECTED ) {
      Serial.println(" Polaczenie WiFi OK");
      Serial.println(WiFi.localIP());
    }
    else {
      Serial.println(" Blad polaczenia Wi-Fi");
    }

    //----- Na OLED -----//
    display.clear();

    if ( fl_LCDoff ) {
      oxx = random(0, 127 - 8);
      oyy = random(0, 63 - 8);
      display.setFont(ArialMT_Plain_16);
      display.drawString(oxx, oyy, TXT_SCREEN_SLEEP );
    }
    else if ( ! ekran ) {   // Ekran urzadzenia lokalnego
#define  DTH_POZ_Y    0
#define BME_POZ_Y   0
#define BME_POZ_X   45
#define  DS_POZ_Y     22
#define  STAT_POZ_Y   50


      char static txt[100]; // kontrola bufora

      if ( dth_presence ) {
        //     sprintf( txt, "%0.0f%% %2.1f*C", dth_h, dth_t );
        sprintf( txt, "%1.0f", dth_h );
        display.setFont(ArialMT_Plain_24);
        display.drawString(oxx + 0, oyy + DTH_POZ_Y, txt );
        display.setFont(ArialMT_Plain_16);
        display.drawString(oxx + 0 + 2 * 14, oyy + DTH_POZ_Y + 7, "%" );
      }
      else {
        display.drawString(oxx + 0, oyy + DTH_POZ_Y, "?");
      }


      if ( StBme280 ) {
        sprintf( txt, "%0.0f", bme_presure / 100 );
        display.setFont(ArialMT_Plain_24);
        display.drawString(oxx + BME_POZ_X, oyy + BME_POZ_Y, txt );
        display.setFont(ArialMT_Plain_16);
        display.drawString(oxx + BME_POZ_X + 4 * 13, oyy + BME_POZ_Y + 7, "hPa" );
      }
      else {
        display.setFont(ArialMT_Plain_16);
        display.drawString(oxx + BME_POZ_X, oyy + BME_POZ_Y, "Err BME" );
      }
      for (byte n = 0; n < MAX_SENSORS && n < device_count; n += 2) {
        uint16_t PoizY = DS_POZ_Y + ((n / 2) * 16);
        display.setFont(ArialMT_Plain_16);
        if ( device_count & 1 && n == device_count - 1) {
          sprintf( txt, "%2.2f", temp[n + 2] );
          display.drawString(oxx + 0, oyy + PoizY, txt );
          drawXbmR(oxx + 40, oyy + PoizY + 3, 16, 12, charStopnie16x12);
          //drawXbm(int16_t xMove, int16_t yMove, int16_t width, int16_t height, const uint8_t *xbm)
        }
        else {
          sprintf( txt, "%2.2f", temp[n + 2] );
          display.drawString(oxx + 0, oyy + PoizY, txt );
          drawXbmR(oxx + 40, oyy + PoizY + 3, 16, 12, charStopnie16x12);
          sprintf( txt, "%2.2f", temp[n + 3] );
          display.drawString(oxx + 70, oyy + PoizY, txt );
          drawXbmR(oxx + 110, oyy + PoizY + 3, 16, 12, charStopnie16x12);
        }
      }
      if ( FL_findDS ) {
        FL_findDS = false;
        char txt[30];
        display.setFont(ArialMT_Plain_10);
        sprintf( txt, "Znaleziono %d DS", device_count);
        display.drawString(oxx + 0, oyy + STAT_POZ_Y, txt );
      }
    }
    else {    // Ekrany zdalne
      uint8_t u = ekran - 1;
      display.setFont(ArialMT_Plain_16);
      //todo: sortowani/wyszukanie "NAME: " wskaxnik na string za "NAME: "
      //rekordy[REK_MAX_URZADZEN][REK_MAX_POL][REK_MAX_STRING];    // bardziej elegancko byloby zrobic strukture
      char name[ REK_MAX_STRING ];
      strncpy( name, rekordy[ u ][1], REK_MAX_STRING );
      display.drawString( 0, 0, name + 6 );

      strncpy( name, rekordy[ u ][3], REK_MAX_STRING ); name[ 5 + 7 ] = 0;
      display.drawString( 0, 16, name + 5 );

      strncpy( name, rekordy[ u ][4], REK_MAX_STRING ); //name[ 5 + 7 ] = 0;
      display.drawString( 64, 16, name + 5 );

      strncpy( name, rekordy[ u ][5], REK_MAX_STRING ); name[ 5 + 7 ] = 0;
      display.drawString( 0, 32, name + 5 );

      strncpy( name, rekordy[ u ][6], REK_MAX_STRING ); //name[ 5 + 7 ] = 0;
      display.drawString( 64, 32, name + 5 );

      strncpy( name, rekordy[ u ][7], REK_MAX_STRING ); name[ 5 + 7 ] = 0;
      display.drawString( 0, 48, name + 5 );

      strncpy( name, rekordy[ u ][8], REK_MAX_STRING ); //name[ 5 + 7 ] = 0;
      display.drawString( 64, 48, name + 5 );
    }
    display.display();
  }


  uint32_t static CzasDoWWW = 10000;
  if ( millis() > CzasDoWWW  ) {
    CzasDoWWW = millis() + 100000UL;
    if (WiFi.status() == WL_CONNECTED)  {

      display.setFont(ArialMT_Plain_10);   //display.setFont(ArialMT_Plain_16);   //  display.setFont(ArialMT_Plain_24);
      display.drawString(oxx + (128 / 3), oyy + STAT_POZ_Y, "ThingSpeak" );
      if ( ! fl_LCDoff ) display.display();

      if ( dth_presence ) {
        ThingSpeak.setField(1, dth_h);
        ThingSpeak.setField(2, dth_t);
      }
      if ( StBme280 ) {
        ThingSpeak.setField(3, bme_presure / 100);
        ThingSpeak.setField(4, bme_temp );
      }
      for (byte n = 0; n < MAX_SENSORS && n < device_count; n++) {
        ThingSpeak.setField(n + 5, temp[n + 2]);
      }
      Serial.println("wysyĹ‚anie danych do serwera...");
      CzasObiegu = millis();
      ThingSpeak.writeFields(myChannelNumber, apiKey);
      Serial.println("wysyĹ‚ano albo i nie");
      //
      Serial.print("Czas wysĹ‚ania do ThingSpeak "); Serial.println( millis() - CzasObiegu);
    }
    else {
      CzasDoWWW = millis() + 15 * 1000UL;
      display.setFont(ArialMT_Plain_10);   //display.setFont(ArialMT_Plain_16);   //  display.setFont(ArialMT_Plain_24);
      display.drawString(oxx + (128 / 3), oyy + STAT_POZ_Y, "** Wi-Fi ERROR **" );
      if ( ! fl_LCDoff ) display.display();

      if ( millis() > CzasDoRstWifi ) {
        millis() + DEF_RESTART_WIFI;

        WiFi.begin();
        display.drawString(oxx + (128 / 3), oyy + (STAT_POZ_Y), "RESTART Wi-Fi" );
        Serial.println("***** Restart Wi-Fi *****");
      }
    }
  }

  uint32_t static petla = 2;


  //----- przez UDP do pirometru
  uint32_t static CzasDoUDP = 20000;
  if ( millis() > CzasDoUDP &&  (WiFi.status() == WL_CONNECTED) ) {
    CzasDoUDP = millis() + 60000UL;

    display.setFont(ArialMT_Plain_10);  //display.setFont(ArialMT_Plain_16);  //  display.setFont(ArialMT_Plain_24);
    display.drawString(128 - 30, STAT_POZ_Y, "UDP" );
    if ( ! fl_LCDoff ) display.display();
    /*
      // UDP.beginPacket("192.168.1.22", port_pirometr);
      UDP.beginPacket(ip_pirometr, port_pirometr);
      UDP.print("Test UDP nr");
      UDP.println(petla - 1);
      UDP.endPacket();
    */
    CzasObiegu = millis();
    for (byte x = 0; x < device_count + 2; x++) {
      //  UDP.beginPacket("192.168.1.22", port_pirometr);
      UDP.beginPacket(ip_pirometr, port_pirometr);
      char buf[50];
      sprintf(buf, "PUT / TXT T%c ", x + 'a');
      UDP.print(buf);
      UDP.println(temp[x]);
      UDP.endPacket();
    }
    Serial.print("Czas wyslania UDP ");  Serial.println( millis() - CzasObiegu);

    Serial.println (NTP.isSummerTime () ? "Summer Time. " : "Winter Time. ");
    Serial.print ("WiFi is "); Serial.println (WiFi.isConnected () ? "connected" : "not connected");

    /*
        //----- przez UDP do pirometru
        uint32_t static CzasDoNTP = 5000;
        if ( millis() > CzasDoNTP &&  (WiFi.status() == WL_CONNECTED) ) {
          CzasDoNTP = millis() + 60000UL;

          //get a random server from the pool
          WiFi.hostByName(ntpServerName, timeServerIP);   // DNS
          Serial.print("****** NTP "); Serial.println( timeServerIP );
          sendNTPpacket(timeServerIP); // send an NTP packet to a time server
          // wait to see if a reply is available
          delay(1000);

          int cb = NtpUdp.parsePacket();
          if (!cb) {
            Serial.println("no packet yet");
          } else {
            Serial.print("packet received, length=");
            Serial.println(cb);
            // We've received a packet, read the data from it
            NtpUdp.read(NtpPacketBuffer, NTP_PACKET_SIZE); // read the packet into the buffer

            //the timestamp starts at byte 40 of the received packet and is four bytes,
            // or two words, long. First, esxtract the two words:

            unsigned long highWord = word(NtpPacketBuffer[40], NtpPacketBuffer[41]);
            unsigned long lowWord = word(NtpPacketBuffer[42], NtpPacketBuffer[43]);
            // combine the four bytes (two words) into a long integer
            // this is NTP time (seconds since Jan 1 1900):
            unsigned long secsSince1900 = highWord << 16 | lowWord;
            Serial.print("Seconds since Jan 1 1900 = ");
            Serial.println(secsSince1900);

            // now convert NTP time into everyday time:
            Serial.print("Unix time = ");
            // Unix time starts on Jan 1 1970. In seconds, that's 2208988800:
            const unsigned long seventyYears = 2208988800UL;
            // subtract seventy years:
            unsigned long epoch = secsSince1900 - seventyYears;
            // print Unix time:
            Serial.println(epoch);


            // print the hour, minute and second:
            Serial.print("The UTC time is ");       // UTC is the time at Greenwich Meridian (GMT)
            Serial.print((epoch  % 86400L) / 3600); // print the hour (86400 equals secs per day)
            Serial.print(':');
            if (((epoch % 3600) / 60) < 10) {
              // In the first 10 minutes of each hour, we'll want a leading '0'
              Serial.print('0');
            }
            Serial.print((epoch  % 3600) / 60); // print the minute (3600 equals secs per minute)
            Serial.print(':');
            if ((epoch % 60) < 10) {
              // In the first 10 seconds of each minute, we'll want a leading '0'
              Serial.print('0');
            }
            Serial.println(epoch % 60); // print the second

          }
       }
    */


    static int i_ntp = 0;
    static int last_ntp = 0;
    if (wifiFirstConnected) {
      wifiFirstConnected = false;
      //     NTP.begin ("pool.ntp.org", timeZone, true, minutesTimeZone);
      NTP.begin ("ntp.itl.waw.pl", timeZone, true, minutesTimeZone);
      //     NTP.setInterval (63);
      NTP.setInterval (20);
      Serial.print ("*****NTP start ");
    }

    if (syncEventTriggered) {
      processSyncEvent(ntpEvent);
      syncEventTriggered = false;
      Serial.println ("*****NTP SYNC ");
    }

    if ((millis () - last_ntp) > 5100 && (WiFi.status() == WL_CONNECTED) ) {
      Serial.println(millis() - last_ntp);
      last_ntp = millis ();
      Serial.print (i_ntp); Serial.print ("*****NTP ");
      Serial.print (NTP.getTimeDateString ()); Serial.print (" ");
      Serial.print (NTP.isSummerTime () ? "Summer Time. " : "Winter Time. ");
      Serial.print ("WiFi is ");
      Serial.print (WiFi.isConnected () ? "connected" : "not connected"); Serial.print (". ");
      Serial.print ("Uptime: ");
      Serial.print (NTP.getUptimeString ()); Serial.print (" since ");
      Serial.println (NTP.getTimeDateString (NTP.getFirstSync ()).c_str ());

      i_ntp++;
    }


  }
  /*
    display.drawString(0, 50, "L=" + String(petla));
    display.display();

    Serial.println("\n\rOczekiwanie 60s...");
    for (int x = 600; x != 0; x--)
    {
      // nie   display.setTextSize(2);
      // nie  display.setTextColor(WHITE);
      // nie  display.setCursor(10,0);
    //     display.drawLine(0, 0, 64, 32);  // poziom, pion, poziom, pion
    //display.drawPixel(10,20,0);

      display.clear();
      //ok    display.setColor(BLACK);
      //ok    display.setPixel(0, 0);
      char txt[20];
      sprintf( txt, "Wait %d.%d", x / 10, x % 10 ); display.drawString(60, 50, txt );
      display.display();
      delay(100);
    }
    Serial.print("Petla ");
    Serial.println(petla++);
  */
}
